diff --git a/src/backend/utils/adt/arrayfuncs.c b/src/backend/utils/adt/arrayfuncs.c
new file mode 100644
index f53a0d2..c2dc1fb
*** a/src/backend/utils/adt/arrayfuncs.c
--- b/src/backend/utils/adt/arrayfuncs.c
*************** array_replace_internal(ArrayType *array,
*** 5398,5403 ****
--- 5398,5411 ----
  		return array;
  	}
  
+ 	/* If all elements were removed return an empty array */
+ 	if (nresult == 0)
+ 	{
+ 		pfree(values);
+ 		pfree(nulls);
+ 		return construct_empty_array(element_type);
+ 	}
+ 
  	/* Allocate and initialize the result array */
  	if (hasnulls)
  	{
diff --git a/src/test/regress/expected/arrays.out b/src/test/regress/expected/arrays.out
new file mode 100644
index 051bac9..4ac1e08
*** a/src/test/regress/expected/arrays.out
--- b/src/test/regress/expected/arrays.out
*************** select array_remove(array['A','CC','D','
*** 1568,1573 ****
--- 1568,1579 ----
  
  select array_remove('{{1,2,2},{1,4,3}}', 2); -- not allowed
  ERROR:  removing elements from multidimensional arrays is not supported
+ select array_remove(array['X','X','X'], 'X') = '{}';
+  ?column? 
+ ----------
+  t
+ (1 row)
+ 
  select array_replace(array[1,2,5,4],5,3);
   array_replace 
  ---------------
diff --git a/src/test/regress/sql/arrays.sql b/src/test/regress/sql/arrays.sql
new file mode 100644
index 04e9725..6dce0dc
*** a/src/test/regress/sql/arrays.sql
--- b/src/test/regress/sql/arrays.sql
*************** select array_remove(array[1,2,2,3], 5);
*** 437,442 ****
--- 437,443 ----
  select array_remove(array[1,NULL,NULL,3], NULL);
  select array_remove(array['A','CC','D','C','RR'], 'RR');
  select array_remove('{{1,2,2},{1,4,3}}', 2); -- not allowed
+ select array_remove(array['X','X','X'], 'X') = '{}';
  select array_replace(array[1,2,5,4],5,3);
  select array_replace(array[1,2,5,4],5,NULL);
  select array_replace(array[1,2,NULL,4,NULL],NULL,5);
